# ImageryProvider

#### new Cesium.ImageryProvider()
Scene/ImageryProvider.js 37

  Provides imagery to be displayed on the surface of an ellipsoid. This type describes an interface and is not intended to be instantiated directly.

  ##### Demo:

  - Cesium Sandcastle Imagery Layers Demo
  - Cesium Sandcastle Imagery Manipulation Demo

  ##### See:

  - ArcGisMapServerImageryProvider
  - SingleTileImageryProvider
  - BingMapsImageryProvider
  - GoogleEarthImageryProvider
  - MapboxImageryProvider
  - createOpenStreetMapImageryProvider
  - WebMapTileServiceImageryProvider
  - WebMapServiceImageryProvider

### Members

#### readonlycredit : Credit
Scene/ImageryProvider.js 217

  Gets the credit to display when this imagery provider is active. Typically this is used to credit the source of the imagery. This function should not be called before `ImageryProvider#ready` returns true.

#### defaultAlpha : Number
Scene/ImageryProvider.js 45

  The default alpha blending value of this provider, with 0.0 representing fully transparent and 1.0 representing fully opaque.
  Default Value: `undefined`

#### defaultBrightness : Number
Scene/ImageryProvider.js 54

  The default brightness of this provider. 1.0 uses the unmodified imagery color. Less than 1.0 makes the imagery darker while greater than 1.0 makes it brighter.
  Default Value: `undefined`

#### defaultContrast : Number
Scene/ImageryProvider.js 63

  The default contrast of this provider. 1.0 uses the unmodified imagery color. Less than 1.0 reduces the contrast while greater than 1.0 increases it.
  Default Value: `undefined`

#### defaultGamma : Number
Scene/ImageryProvider.js 88

  The default gamma correction to apply to this provider. 1.0 uses the unmodified imagery color.
  Default Value: `undefined`

#### defaultHue : Number
Scene/ImageryProvider.js 71

  The default hue of this provider in radians. 0.0 uses the unmodified imagery color.
  Default Value: `undefined`

#### defaultSaturation : Number
Scene/ImageryProvider.js 80

  The default saturation of this provider. 1.0 uses the unmodified imagery color. Less than 1.0 reduces the saturation while greater than 1.0 increases it.
  Default Value: `undefined`

#### readonlyerrorEvent : Event
Scene/ImageryProvider.js 205

  Gets an event that is raised when the imagery provider encounters an asynchronous error.. By subscribing to the event, you will be notified of the error and can potentially recover from it. Event listeners are passed an instance of `TileProviderError`.

#### readonlyhasAlphaChannel : Boolean
Scene/ImageryProvider.js 241

  Gets a value indicating whether or not the images provided by this imagery provider include an alpha channel. If this property is false, an alpha channel, if present, will be ignored. If this property is true, any images without an alpha channel will be treated as if their alpha is 1.0 everywhere. When this property is false, memory usage and texture upload time are reduced.

#### readonlymaximumLevel : Number
Scene/ImageryProvider.js 154

  Gets the maximum level-of-detail that can be requested. This function should not be called before `ImageryProvider#ready` returns true.

#### readonlyminimumLevel : Number
Scene/ImageryProvider.js 169

  Gets the minimum level-of-detail that can be requested. This function should not be called before `ImageryProvider#ready` returns true. Generally, a minimum level should only be used when the rectangle of the imagery is small enough that the number of tiles at the minimum level is small. An imagery provider with more than a few tiles at the minimum level will lead to rendering problems.

#### readonlyproxy : Proxy
Scene/ImageryProvider.js 227

  Gets the proxy used by this provider.

#### readonlyready : Boolean
Scene/ImageryProvider.js 100

  Gets a value indicating whether or not the provider is ready for use.

#### readonlyreadyPromise : Promise.<Boolean>
Scene/ImageryProvider.js 110

  Gets a promise that resolves to true when the provider is ready for use.

#### readonlyrectangle : Rectangle
Scene/ImageryProvider.js 121

  Gets the rectangle, in radians, of the imagery provided by the instance. This function should not be called before `ImageryProvider#ready` returns true.

#### readonlytileDiscardPolicy : TileDiscardPolicy
Scene/ImageryProvider.js 193

  Gets the tile discard policy. If not undefined, the discard policy is responsible for filtering out "missing" tiles via its shouldDiscardImage function. If this function returns undefined, no tiles are filtered. This function should not be called before `ImageryProvider#ready` returns true.

#### readonlytileHeight : Number
Scene/ImageryProvider.js 143

  Gets the height of each tile, in pixels. This function should not be called before `ImageryProvider#ready` returns true.

#### readonlytileWidth : Number
Scene/ImageryProvider.js 132

  Gets the width of each tile, in pixels. This function should not be called before `ImageryProvider#ready` returns true.

#### readonlytilingScheme : TilingScheme
Scene/ImageryProvider.js 180

  Gets the tiling scheme used by the provider. This function should not be called before `ImageryProvider#ready` returns true.

### Methods

#### staticCesium.ImageryProvider.loadImage(url) → Promise.<(Image|Canvas)>|undefined
Scene/ImageryProvider.js 308

  Loads an image from a given URL. If the server referenced by the URL already has too many requests pending, this function will instead return undefined, indicating that the request should be retried later.

  Name | Type | Description
  --- | --- | ---
  `url` | String | The URL of the image.

  ##### Returns:

  A promise for the image that will resolve when the image is available, or undefined if there are too many active requests to the server, and the request should be retried later. The resolved image may be either an Image or a Canvas DOM object.

#### getTileCredits(x, y, level) → Array.<Credit>
Scene/ImageryProvider.js 257

  Gets the credits to be displayed when a given tile is displayed.

  Name | Type | Description
  --- | --- | ---
  `x` | Number | The tile X coordinate.
  `y` | Number | The tile Y coordinate.
  `level` | Number | The tile level;

  ##### Returns:

  The credits to be displayed when the tile is displayed.

  ##### Throws:

  - DeveloperError : `getTileCredits` must not be called before the imagery provider is ready.

#### pickFeatures(x, y, level, longitude, latitude) → Promise.<Array.<ImageryLayerFeatureInfo>>|undefined
Scene/ImageryProvider.js 295

  Asynchronously determines what features, if any, are located at a given longitude and latitude within a tile. This function should not be called before `ImageryProvider#ready` returns true. This function is optional, so it may not exist on all ImageryProviders.

  Name | Type | Description
  --- | --- | ---
  `x` | Number | The tile X coordinate.
  `y` | Number | The tile Y coordinate.
  `level` | Number | The tile level.
  `longitude` | Number | The longitude at which to pick features.
  `latitude` | Number | The latitude at which to pick features.

  ##### Returns:

  A promise for the picked features that will resolve when the asynchronous picking completes. The resolved value is an array of `ImageryLayerFeatureInfo` instances. The array may be empty if no features are found at the given location. It may also be undefined if picking is not supported.

  ##### Throws:

  - DeveloperError : `pickFeatures` must not be called before the imagery provider is ready.

#### requestImage(x, y, level) → Promise.<(Image|Canvas)>|undefined
Scene/ImageryProvider.js 274

  Requests the image for a given tile. This function should not be called before `ImageryProvider#ready` returns true.

  Name | Type | Description
  --- | --- | ---
  `x` | Number | The tile X coordinate.
  `y` | Number | The tile Y coordinate.
  `level` | Number | The tile level.

  ##### Returns:

  A promise for the image that will resolve when the image is available, or undefined if there are too many active requests to the server, and the request should be retried later. The resolved image may be either an Image or a Canvas DOM object.

  ##### Throws:

  - DeveloperError : `requestImage` must not be called before the imagery provider is ready.